#!/bin/ksh

#set -A pkname atk cairo expat fontconfig freetype2 gettext glib2 gtk2 libjpeg libpng libtiff pango pixman xcursor xft xrender zlib
set -A pkname atk cairo expat zlib freetype2 fontconfig gettext glib2 libpng libtiff libjpeg xrender xft pango xcursor pixman gtk2
#set -A pkversion 1.12.3 1.8.8 2.0.1 2.4.2 2.3.9 0.10.40 2.12.4 2.10.6 6b 1.2.32 3.8.2 1.14.5 0.12.0 1.1.7 2.1.6 0.9.1 1.2.3

set -A pkversion 1.12.3.2 1.8.8.1 2.0.1.1 1.2.3.3 2.3.9.1 2.4.2.1 0.10.40.6 2.12.4.2 1.2.32.2 3.8.2.1 6b.6 0.9.1.3 2.1.6.5 1.14.5.4 1.1.7.3 0.12.0.3 2.10.6.4
let "index=0"
for pk in ${pkname[@]}
do
	large=0
        #multiple=$(rpm -qa --qf "%{NAME} %{VERSION}\n" | grep $pk | wc -l)
        #let "flag=0"
        #if [ "$multiple" -gt 1 ];
        #then
	set -A pkcurr ""
        let "flag=0"
                rpm -qa --qf "%{NAME} %{VERSION}.%{RELEASE}\n" | grep $pk | while read line; do
                        set -A pktest $line
#                        echo " ${pktest[0]} == $pk "
                        if [ ${pktest[0]} == $pk ]
                        then
				set -A pkcurr $line	
                                if [  ${pktest[1]} == ${pkversion[$index]} ]
                                then
                                        let "flag=1"
                                fi
                        fi
                done
        #fi
        if [ "$flag" -eq 1 ];
        then
                echo "Package ${pkcurr[0]} already installed"
                let "index=index+1"
                continue;
        fi
#	echo $pk,${pkversion[$index]}
#	set -A pkcurr $(rpm -qa --qf "%{NAME} %{VERSION}\n" | grep $pk) 
#	echo ${pkcurr[0]},${pkcurr[1]}
#	echo ${#pkcurr[@]}	
#	echo ${#pkcurr[@]},${pkcurr[0]},${pkcurr[1]},"for $pk"
	if [ 2 -gt ${#pkcurr[@]} ];
	then
		echo "Package: $pk, not installed"
		echo "Installing: $pk"
		rfile=$( ls *.rpm | grep $pk )
		rpm --nodeps -ivh $rfile		
		let "index=index+1"
		continue
	fi
#	if [ ${pkversion[$index]} != ${pkcurr[1]} ]
#	then
#		echo "Version installed: ${pkcurr[1]}"," Version to be installed: ${pkversion[$index]} for package: ${pkcurr[0]}"
#		echo "Do you want to overwrite existing installation?"	
#		read yn
#		case $yn in
#			[Yy]* ) echo "Installing Package";rfile=$( ls *.rpm | grep $pk );rpm -ivh --force $rfile;;
#			* ) echo "Leaving package as it is."
#		esac
#	fi
	#echo "multiple=$multiple"	
	large=$(echo  ${pkcurr[1]} ${pkversion[$index]}  | \
      	 awk '{ split($1, a, ".");
      	 split($2, b, ".");
      	 for (i = 1; i <= 4; i++)
       	    if (a[i] < b[i]) {
       	        x =-1;
       	        break;
       	    } else if (a[i] > b[i]) {
       	        x = 1;
       	        break;
       	    }
      	 print x;
    	 }')
	if [ "$large" -eq 1 ];
	then
               echo "Higher Version installed: ${pkcurr[1]}"," Version to be installed: ${pkversion[$index]} for package: ${pkcurr[0]}"
	       echo "Do you want to downgrade installation?"
               read yn
               case $yn in
                      [Yy]* ) echo "Installing Package";rfile=$( ls *.rpm | grep $pk );rpm -Uvh --oldpackage $rfile;;
                       * ) echo "Leaving package as it is."
               esac
	elif [ "$large" -eq -1 ];
	then
		echo "Lower Version installed: ${pkcurr[1]}"," Version to be installed: ${pkversion[$index]} for package: ${pkcurr[0]}"
                echo "Do you want to uprade installation?"
                read yn
                case $yn in
                       [Yy]* ) echo "Installing Package";rfile=$( ls *.rpm | grep $pk );rpm -Uvh $rfile;;
                        * ) echo "Leaving package as it is."		
		esac	
	fi			
	let "index=index+1"
done 
